﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;

namespace UltraTreeDepthTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraTree1.ShowRootLines = true;
            RadioButtonCheckedChanged(radioButton1, EventArgs.Empty);
        }

        private readonly Node node0 = new Node("Node (no children)");

        private readonly Node node1 =
            new Node("Node (level 1)",
            new Node("Node (level 2)",
            new Node("Node (level 3)")));

        private void RadioButtonCheckedChanged(object sender, EventArgs e)
        {
            BindingList<Node> nodes = new BindingList<Node>();            
            if (radioButton1.Checked)
            {
                nodes.Add(node0);
                nodes.Add(node1);
            }
            else
            {
                nodes.Add(node1);
                nodes.Add(node0);
            }
            this.ultraTree1.DataSource = nodes;

            ultraTree1.ExpandAll(ExpandAllType.Always);
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }

    public class Node 
    {
        public Node()
        {            
            this.children = new BindingList<Node>();            
        }

        public Node(string text, params Node[] children)
        {
            Text = text;
            this.children = new BindingList<Node>();
            foreach (Node node in children)
                this.children.Add(node);
        }

        public string Text { get; private set; }

        private BindingList<Node> children;

        public BindingList<Node> Children
        {
            get { return children; }
        }
    }    
}